// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef WCSINFO_H
#define WCSINFO_H

#include <iostream>
#include <vector>
#include "CalServer.h"
#include "Dal.h"
#include "wcs.h"
#include "WCSConvertor.h"

class WCSinfo {

public:
	WCSinfo(Array * block, std::string coordtype, std::string shape_bkg_1strow, std::vector<double> src_and_bkg_regions);
	CoordPair getRefPixels();
	CoordPair getRefCoords();
	CoordPair getPixelSizeWorld();
	std::string getxType();
	std::string getyType();
	//const char * getxType();
	//const char * getyType();
	std::string getXUnit();
	std::string getYUnit();
	real64 getrotAngle();
	std::vector<real64> getMatrixOnOffAxis();
	std::vector<double> getPixVec();

private:
	bool checkWCS();
	void readWCS();
	void convertWorldtoPixel();
	//DataSet *_ds;
	Array *_array;
	std::string _coordtype;
	std::string _shape_bkg_1strow;

	std::string _ctype1;
	std::string _ctype2;
	//const char * _ctype1;
	//const char * _ctype2;
	real64 _crpix1;
	real64 _crpix2;
	real64 _crval1;
	real64 _crval2;
	real64 _cdelt1;
	real64 _cdelt2;
	real64 _rotAngle;
	real64 _xMatrixOnAxis;
	real64 _xMatrixOffAxis;
	real64 _yMatrixOnAxis;
	real64 _yMatrixOffAxis;
	real64 _xPixelSizeWorld;
	real64 _yPixelSizeWorld;
	std::vector<real64> _MatrixOnOffAxis;
	void convertOldToNew();
	std::string _XworldUnit;
	std::string _YworldUnit;
	std::vector<double> _src_and_bkg_regions;
	std::vector<double> _pixVec;

	//CoordPair refPixels;
	//CoordPair refCoords;

	//
	// For WCSConvertor
	//CoordPair _physicalRefPix;
	//CoordPair _physicalRefCoords;
	//double _xPixelSizeWorld;
	//double _yPixelSizeWorld;
	//

};

#endif
