// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef PLOTIMAGE_H
#define PLOTIMAGE_H

#include <iostream>
#include <vector>
#include "Dal.h"
#include "Task.h"

class plotImage {

public:
	plotImage(float* image, std::vector<double> effMinMax, std::vector<int> size, std::vector<int> xy_limits, std::string imagefile, std::string instr, std::string datamode, std::string submode, std::string filter, std::string object, std::string observer, std::string date_obs, double exposure, std::string spec_file, int src_num_src);
	//std::vector<double> getPlot();

private:
	void calPlot();
	void set_palette();
	void plotRHinfo();
	float* TransformMatrix();
	float* _image;
	std::vector<double> _effMinMax;
	std::vector<int> _size;
	std::vector<int> _xy_limits;
	float _rhCharX;
	float _rhCharDy;
	float _rhCharXindent;
	float _rhCharYindent;
	float _rhCharSize;
	std::string _imagefile;
	std::string _instr;
	std::string _datamode;
	std::string _submode;
	std::string _filter;
	std::string _object;
	std::string _observer;
	std::string _date_obs;
	std::string _imageTransferStyle;
	double _exposure;
	std::string _spec_file;
	int _minx;
	int _maxx;
	int _miny;
	int _maxy;
	int _src_num_src;
	//void calRegMOS_small();
	//std::vector<int> calCCDlimits();
	//double _rawx;
	//double _rawy;
	//int _ccdnr;
	//double _rad;
	//std::vector<int> ccd_limits;
	//std::string _device;
	//std::string _instr;
	//std::string _mode;
	//std::vector<double> _res;

};

#endif
